@echo off

set ISO_FILE=%~1
set ISO_DIR=%~2
set ISO_CMD=mkisofs-orig

set WRAP_ENABLED=0
for /R plugin %%i in (*.inf) do call :self_check "%%i"
if not %WRAP_ENABLED% == 1 echo ISO Wrapper disabled & goto build_iso

echo Processing PRE_ISO
set PLUGIN_CMD=pre_iso.cmd
echo Scaning plugins...
for /R plugin %%i in (*.inf) do call :plugin_check "%%i"

call :build_iso
if errorlevel 1 goto :EOF

echo Processing POST_ISO
set PLUGIN_CMD=post_iso.cmd
echo Scaning plugins...
for /R plugin %%i in (*.inf) do call :plugin_check "%%i"

goto :EOF

:self_check
if /i "%~n1" NEQ "isowrapper" goto :EOF
type %1 | find /i "enable=1" >nul && set WRAP_ENABLED=1
goto :EOF

:plugin_check
if not exist "%~dp1%PLUGIN_CMD%" goto :EOF
type %1 | find /i "[pebuilder]" >nul || goto :EOF
type %1 | find /i "enable=1" >nul || goto :EOF
echo Executing: %~dp1%PLUGIN_CMD%
pushd "%~dp1"
call %PLUGIN_CMD%
popd
goto :EOF

:build_iso
echo Executing ISO build command
echo %ISO_CMD% %ISO_OPTS%
%ISO_CMD% %ISO_OPTS%
goto :EOF
